.\"	$NetBSD: shuffle.1,v 1.7 2009/02/18 13:42:06 yamt Exp $
.\"
.\" Copyright (c) 1998
.\" 	Perry E. Metzger.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgment:
.\"	This product includes software developed for the NetBSD Project
.\"	by Perry E. Metzger.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.Dd February 18, 2009
.Dt SHUFFLE 1
.Os
.Sh NAME
.Nm shuffle
.Nd print a random permutation of the command line arguments
.Sh SYNOPSIS
.Nm
.Op Fl 0
.Op Fl f Ar filename ...
.Op Fl n Ar number
.Op Fl p Ar number
.Op Ar arg
.Op Ar ...
.Sh DESCRIPTION
The
.Nm
program prints a random permutation (or
.Dq shuffle )
of its command line arguments.
This can be useful in shell scripts for selecting a
random order in which to do a set of tasks, view a set of files, etc.
.Pp
If the
.Fl f
option is given, the data is taken from that files' contents or if the
filename is
.Ar -
.Dq stdin .
.Pp
If the
.Fl n
option is given, its argument is treated as a number, and the program
prints a random permutation of the numbers greater than or equal to 0
and less than the argument.
.Pp
If the
.Fl p
option is given, its argument is treated as a number, and the program
prints that number of randomly selected lines or arguments in a random order.
.Pp
The
.Fl 0
option changes the field separator character from \en to \e0, so that
the output is suitable to be sent to
.Xr xargs 1
(to handle filenames with whitespace in them).
.Sh EXAMPLES
.Bd -literal -offset indent
$ shuffle a b c d
c
b
d
a
$ shuffle -p 1 a b c d
d
$ shuffle -n 4 -p 2
0
3
.Ed
.Sh SEE ALSO
.Xr jot 1 ,
.Xr random 6
.Sh HISTORY
The
.Nm
program first appeared in
.Nx 1.4 .
.Sh AUTHORS
Written by
.An Perry E. Metzger
.Aq perry@piermont.com .
